/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     nj_dic.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/

#ifndef _NJ_DIC_H_
#define _NJ_DIC_H_

#ifdef __cplusplus 
extern "C" {
#endif


/************************************************/
/*            Constant definitions                          */
/************************************************/
#define NJ_DIC_TYPE_JIRITSU                     0x00000000      /* Please see man pages for details */
#define NJ_DIC_TYPE_FZK                         0x00000001      /* Please see man pages for details */
#define NJ_DIC_TYPE_TANKANJI                    0x00000002      /* Please see man pages for details */
#define NJ_DIC_TYPE_CUSTOM_COMPRESS             0x00000003      /* Please see man pages for details */
#define NJ_DIC_TYPE_STDFORE                     0x00000004      /* Please see man pages for details */
#define NJ_DIC_TYPE_FORECONV                    0x00000005      /* Please see man pages for details */
#define NJ_DIC_TYPE_YOMINASHI                   0x00010000      /* Please see man pages for details */
#define NJ_DIC_TYPE_LEARN                       0x80020000      /* Please see man pages for details */
#define NJ_DIC_TYPE_CUSTOM_INCOMPRESS           0x00020002      /* Please see man pages for details */
#define NJ_DIC_TYPE_CUSTOM_INCOMPRESS_LEARN     0x00020003      /* Please see man pages for details */
#define NJ_DIC_TYPE_USER                        0x80030000      /* Please see man pages for details */
#define NJ_DIC_TYPE_RULE                        0x000F0000      /* Please see man pages for details */
#define NJ_DIC_TYPE_EXT_YOMINASI                0x00040000      /* Please see man pages for details */
#define NJ_DIC_TYPE_FUSION_AWNN                 0x00000006      /* Please see man pages for details */
#define NJ_DIC_TYPE_FUSION                      0x00050000      /* Please see man pages for details */
#define NJ_DIC_TYPE_PROGRAM                     0x000E0000      /* Please see man pages for details */
#define NJ_DIC_TYPE_PROGRAM_FZK                 0x000E0001      /* Please see man pages for details */

/* Part of speech type required by the conversion block */
#define NJ_HINSI_V2_F            0      /* Please see man pages for details */
#define NJ_HINSI_GIJI_F          1      /* Please see man pages for details */
#define NJ_HINSI_GIJI_B          2      /* Please see man pages for details */
#define NJ_HINSI_SUUJI_B        14      /* Please see man pages for details */
#define NJ_HINSI_BUNTOU_B        3      /* Please see man pages for details */
/* Part of speech type required by the evaluation block */
#define NJ_HINSI_TANKANJI_F      4      /* Please see man pages for details */
#define NJ_HINSI_TANKANJI_B      5      /* Please see man pages for details */
/* Part of speech group */
#define NJ_HINSI_MEISI_F         6      /* Please see man pages for details */
#define NJ_HINSI_MEISI_B         7      /* Please see man pages for details */
#define NJ_HINSI_JINMEI_F        8      /* Please see man pages for details */
#define NJ_HINSI_JINMEI_B        9      /* Please see man pages for details */
#define NJ_HINSI_MEISI_NO_CONJ_F 10     /* Please see man pages for details */
#define NJ_HINSI_MEISI_NO_CONJ_B 11     /* Please see man pages for details */
#define NJ_HINSI_CHIMEI_F       10      /* Please see man pages for details */
#define NJ_HINSI_CHIMEI_B       11      /* Please see man pages for details */
#define NJ_HINSI_KIGOU_F        12      /* Please see man pages for details */
#define NJ_HINSI_KIGOU_B        13      /* Please see man pages for details */
#define NJ_HINSI_V1_F           15      /* Please see man pages for details */
#define NJ_HINSI_V3_F           16      /* Please see man pages for details */

#define NJ_RULE_TYPE_BTOF       0
#define NJ_RULE_TYPE_FTOB       1

#define NJD_SAME_INDEX_LIMIT    50

#define HGROUP_COUNT            2

/************************************************/
/*           Macro definitions                         */
/************************************************/
#define NJ_INT16_READ(in)                                               \
    (((((s16)((in)[0])) << 8) & 0xff00U) + ((in)[1] & 0xffU))

#define NJ_INT32_READ(in)                                               \
    (((((s32)((in)[0])) << 24) & 0xff000000) |                     \
     ((((s32)((in)[1])) << 16) &   0xff0000) |                     \
     ((((s32)((in)[2])) <<  8) &     0xff00) |                     \
     ((((s32)((in)[3]))      ) &       0xff))

#define NJ_INT32_WRITE(to, from)\
        {(to)[0]=(u8)(((from)>>24) & 0x000000ff);\
         (to)[1]=(u8)(((from)>>16) & 0x000000ff);\
         (to)[2]=(u8)(((from)>>8) & 0x000000ff);\
         (to)[3]=(u8)((from) & 0x000000ff);}

#define NJ_INT16_WRITE(to, from)\
        {(to)[0]=(u8)(((from)>>8) & 0x00ff);\
         (to)[1]=(u8)((from) & 0x00ff);}

#define NJ_GET_MAX_YLEN(h) ((s16)(NJ_INT16_READ((h)+0x16)/sizeof(wchar_t)))

#define NJ_GET_MAX_KLEN(h) ((s16)(NJ_INT16_READ((h)+0x1A)/sizeof(wchar_t)))

#define NJ_GET_DIC_TYPE(h) ((u32)(NJ_INT32_READ((h)+8)))

#define NJ_CHECK_USE_DIC_FREQ(df) (((df)->high < (df)->base) ? 0 : 1)

/************************************************/
/*           Data structure definitions                     */
/************************************************/


#ifdef __cplusplus 
}
#endif
#endif /* _NJ_DIC_H_ */
