/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     nj_err.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
#ifndef _NJ_ERR_H_
#define _NJ_ERR_H_

#ifdef __cplusplus 
extern "C" {
#endif


/************************************************/
/*                Macro definitions                    */
/************************************************/
/*
 * Error code access Macro definitions
 */
#define NJ_ERR_CODE_MASK        (0x7F00)        /* Please see man pages for details */
#define NJ_ERR_FUNC_MASK        (0x00FF)        /* Please see man pages for details */

/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_ERR_CODE(x)      ((x) & NJ_ERR_CODE_MASK)
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_ERR_FUNC(x)      ((x) & NJ_ERR_FUNC_MASK)

#define NJ_SET_ERR_VAL(x, y)    ((s16)((x) | (y) | 0x8000))

/************************************************/
/*                 Constant definitions                     */
/************************************************/
/*
 *  Error Codes
 */
#define NJ_ERR_PARAM_DIC_NULL                       (0x0000) /* Please see man pages for details */
#define NJ_ERR_PARAM_YOMI_NULL                      (0x0100) /* Please see man pages for details */
#define NJ_ERR_PARAM_YOMI_SIZE                      (0x0200) /* Please see man pages for details */
#define NJ_ERR_PARAM_KUGIRI                         (0x0300) /* Please see man pages for details */
#define NJ_ERR_PARAM_ILLEGAL_LEVEL                  (0x0400) /* Please see man pages for details */
#define NJ_ERR_PARAM_RESULT_NULL                    (0x0500) /* Please see man pages for details */
#define NJ_ERR_YOMI_TOO_LONG                        (0x0600) /* Please see man pages for details */
#define NJ_ERR_NO_HINSI                             (0x0700) /* Please see man pages for details */
#define NJ_ERR_NO_RULEDIC                           (0x0800) /* Please see man pages for details */
#define NJ_ERR_PARAM_OPERATION                      (0x0900) /* Please see man pages for details */
#define NJ_ERR_PARAM_MODE                           (0x0A00) /* Please see man pages for details */
#define NJ_ERR_PARAM_KANJI_NULL                     (0x0B00) /* Please see man pages for details */
#define NJ_ERR_CANDIDATE_TOO_LONG                   (0x0C00) /* Please see man pages for details */
#define NJ_ERR_PARAM_CURSOR_NULL                    (0x0D00) /* Please see man pages for details */
#define NJ_ERR_DIC_TYPE_INVALID                     (0x0E00) /* Please see man pages for details */
#define NJ_ERR_DIC_HANDLE_NULL                      (0x0F00) /* Please see man pages for details */
#define NJ_ERR_FORMAT_INVALID                       (0x1000) /* Please see man pages for details */
#define NJ_ERR_NO_CANDIDATE_LIST                    (0x1100) /* Please see man pages for details */
#define NJ_ERR_NOT_CONVERTED                        (0x1200) /* Please see man pages for details */
#define NJ_ERR_AREASIZE_INVALID                     (0x1300) /* Please see man pages for details */
#define NJ_ERR_BUFFER_NOT_ENOUGH                    (0x1400) /* Please see man pages for details */
#define NJ_ERR_HINSI_GROUP_INVALID                  (0x1500) /* Please see man pages for details */
#define NJ_ERR_CREATE_TYPE_INVALID                  (0x1600) /* Please see man pages for details */
#define NJ_ERR_WORD_INFO_NULL                       (0x1700) /* Please see man pages for details */
#define NJ_ERR_DIC_NOT_FOUND                        (0x1800) /* Please see man pages for details */
#define NJ_ERR_CANNOT_GET_QUE                       (0x1900) /* Please see man pages for details */
#define NJ_ERR_INVALID_FLAG                         (0x1A00) /* Please see man pages for details */
#define NJ_ERR_INVALID_RESULT                       (0x1B00) /* Please see man pages for details */
#define NJ_ERR_NOT_SELECT_YET                       (0x1C00) /* Please see man pages for details */
#define NJ_ERR_INTERNAL                             (0x1D00) /* Please see man pages for details */
#define NJ_ERR_USER_YOMI_INVALID                    (0x1E00) /* Please see man pages for details */
#define NJ_ERR_USER_KOUHO_INVALID                   (0x1F00) /* Please see man pages for details */
#define NJ_ERR_USER_DIC_FULL                        (0x2000) /* Please see man pages for details */
#define NJ_ERR_SAME_WORD                            (0x2100) /* Please see man pages for details */
#define NJ_ERR_DIC_BROKEN                           (0x2200) /* Please see man pages for details */
#define NJ_ERR_CANNOT_RESTORE                       (0x2300) /* Please see man pages for details */
#define NJ_ERR_WORD_NOT_FOUND                       (0x2400) /* Please see man pages for details */
#define NJ_ERR_PARAM_NORMAL_NULL                    (0x2500) /* Please see man pages for details */
#define NJ_ERR_PARAM_TYPE_INVALID                   (0x2600) /* Please see man pages for details */
#define NJ_ERR_PARAM_PROCESS_LEN_NULL               (0x2700) /* Please see man pages for details */
#define NJ_ERR_CANNOT_USE_MORPHOLIZE                (0x2800) /* Please see man pages for details */
#define NJ_ERR_PARAM_ILLEGAL_LIMIT                  (0x2900) /* Please see man pages for details */
#define NJ_ERR_DIC_VERSION_INVALID                  (0x2A00) /* Please see man pages for details */
#define NJ_ERR_DIC_FREQ_INVALID                     (0x2B00) /* Please see man pages for details */
#define NJ_ERR_CACHE_NOT_ENOUGH                     (0x2C00) /* Please see man pages for details */
#define NJ_ERR_CACHE_BROKEN                         (0x2D00) /* Please see man pages for details */
#define NJ_ERR_PARAM_ENV_NULL                       (0x2E00) /* Please see man pages for details */
#define NJ_ERR_PARAM_EXT_AREA_NULL                  (0x2F00) /* Please see man pages for details */
#define NJ_ERR_PARAM_EXT_AREA_INVALID_SIZE          (0x3000) /* Please see man pages for details */
#define NJ_ERR_PARAM_ANALYZE_OPTION_NULL            (0x3100) /* Please see man pages for details */
#define NJ_ERR_PARAM_ILLEGAL_CHAR_LEN               (0x3200) /* Please see man pages for details */
#define NJ_ERR_PARAM_STATE_NULL                     (0x3300) /* Please see man pages for details */
#define NJ_ERR_PARAM_SIZE_NULL                      (0x3400) /* Please see man pages for details */
#define NJ_ERR_PARAM_INVALID_STATE                  (0x3500) /* Please see man pages for details */
#define NJ_ERR_PROTECTION_ERROR                     (0x3600) /* Please see man pages for details */
#define NJ_ERR_PARAM_INDEX_INVALID                  (0x3700) /* Please see man pages for details */
#define NJ_ERR_USER_ADDITIONAL_INVALID              (0x3800) /* Please see man pages for details */
#define NJ_ERR_PARAM_ADD_INFO_NULL                  (0x3900) /* Please see man pages for details */
#define NJ_ERR_PARAM_ADD_INFO_INVALID_SIZE          (0x3A00) /* Please see man pages for details */
#define NJ_ERR_PARAM_STREAM_NULL                    (0x3B00) /* Please see man pages for details */
#define NJ_ERR_STREAM_SEEK_ERR                      (0x3C00) /* Please see man pages for details */
#define NJ_ERR_STREAM_READ_ERR                      (0x3D00) /* Please see man pages for details */
#define NJ_ERR_PARAM_NULL                           (0x3E00) /* Please see man pages for details */


/*
 * Error function code
 */
/* Morphological parsing block */
#define NJ_FUNC_MM_SPLIT_WORD                       (0x0070)
#define NJ_FUNC_MM_GET_YOMI                         (0x0073)
#define NJ_FUNC_MM_GET_HINSI                        (0x0072)
#define NJ_FUNC_MM_SELECT                           (0x0071)

/* Conversion block */
#define NJ_FUNC_NJ_CONV                             (0x0000)
#define NJ_FUNC_NJ_ZENKOUHO                         (0x0001)
#define NJ_FUNC_CONV_MULTICONV                      (0x0002)
#define NJ_FUNC_CONV_STEMPROCESS                    (0x0003)
#define NJ_FUNC_CONV_FZKPROCESS                     (0x0004)
#define NJ_FUNC_CONV_ENV_SET                        (0x0005)
#define NJ_FUNC_CONV_GIJIPROCESS                    (0x0006)
#define NJ_FUNC_CAND_ENV_SET                        (0x0007)
#define NJ_FUNC_CAND_GETCANDIDATE                   (0x0008)
#define NJ_FUNC_GET_STROKE_WORD                     (0x0009)

/* Dictionary block */
/* Compressed dictionary adapter */
#define NJ_FUNC_NJD_B_GET_CANDIDATE                 (0x0010)
#define NJ_FUNC_NJD_B_GET_STROKE                    (0x0061)
#define NJ_FUNC_NJD_B_SEARCH_WORD                   (0x0062)

/* No reading dictionary adapter */
#define NJ_FUNC_NJD_F_GET_WORD                      (0x0011)
#define NJ_FUNC_NJD_F_GET_STROKE                    (0x0012)
#define NJ_FUNC_NJD_F_GET_CANDIDATE                 (0x0013)
/* Learning dictionary adapter */
#define NJ_FUNC_NJD_L_DELETE_WORD                   (0x0014)
#define NJ_FUNC_NJD_L_ADD_WORD                      (0x0015)
#define NJ_FUNC_NJD_L_UNDO_LEARN                    (0x0016)
#define NJ_FUNC_DELETE_INDEX                        (0x0017)
#define NJ_FUNC_INSERT_INDEX                        (0x0018)
#define NJ_FUNC_QUE_STRCMP_COMPLETE_WITH_HYOUKI     (0x0019)
#define NJ_FUNC_NJD_L_GET_WORD                      (0x001B)
#define NJ_FUNC_NJD_L_GET_CANDIDATE                 (0x001C)
#define NJ_FUNC_NJD_L_GET_STROKE                    (0x001D)
#define NJ_FUNC_QUE_STRCMP_FORWARD                  (0x001E)
#define NJ_FUNC_NJD_L_CHECK_DIC                     (0x001F)
#define NJ_FUNC_SEARCH_RANGE_BY_YOMI                (0x0020)
#define NJ_FUNC_STR_QUE_CMP                         (0x0021)
#define NJ_FUNC_WRITE_LEARN_DATA                    (0x0022)
#define NJ_FUNC_NJD_L_GET_ADDITIONAL_INFO           (0x0096)
/* Rule dictionary adapter */
#define NJ_FUNC_NJD_R_CHECK_GROUP                   (0x0064)

/* Integrated dictionary adapter */
#define NJ_FUNC_NJD_T_SEARCH_WORD                   (0x0080)
#define NJ_FUNC_NJD_T_GET_CANDIDATE                 (0x0081)
#define NJ_FUNC_NJD_T_GET_STROKE                    (0x0082)
#define NJ_FUNC_NJD_T_GET_RELATIONAL_WORD           (0x0085)
#define NJ_FUNC_NJD_T_GET_ADD_INFO                  (0x0098)
#define NJ_FUNC_NJD_T_INIT_EXT_AREA                 (0x008C)
#define NJ_FUNC_NJD_T_CHECK_EXT_AREA                (0x008F)
#define NJ_FUNC_NJD_T_CHECK_ADD_INFO                (0x0094)
#define NJ_FUNC_NJD_T_GET_FLASH_DIC_CACHE_SIZE      (0x009D)
#define NJ_FUNC_NJD_T_SET_FLASH_DIC_INFO            (0x009E)

/* Extended no reading prediction dictionary adapter */
#define NJ_FUNC_NJD_P_GET_CANDIDATE                 (0x0091)
#define NJ_FUNC_NJD_P_GET_STROKE                    (0x0092)
#define NJ_FUNC_NJD_P_GET_ADD_INFO                  (0x0099)
#define NJ_FUNC_NJD_P_CHECK_ADD_INFO                (0x0097)

/* Dictionary lookup block, API interface block */
#define NJ_FUNC_CHECK_SEARCH_CURSOR                 (0x0023)
#define NJ_FUNC_GET_WORD_AND_SEARCH_NEXT_WORD       (0x0024)

#define NJ_FUNC_NJD_GET_WORD_DATA                   (0x0025)
#define NJ_FUNC_NJD_GET_RELATIONAL_WORD             (0x0026)
#define NJ_FUNC_NJD_GET_WORD                        (0x0027)
#define NJ_FUNC_NJD_CHECK_DIC                       (0x0028)

#define NJ_FUNC_NJ_CREATE_DIC                       (0x0029)
#define NJ_FUNC_NJD_GET_STROKE                      (0x002A)
#define NJ_FUNC_NJD_GET_CANDIDATE                   (0x002B)
#define NJ_FUNC_NJ_SEARCH_WORD                      (0x002C)
#define NJ_FUNC_NJ_GET_WORD                         (0x002D)
#define NJ_FUNC_NJ_ADD_WORD                         (0x002E)
#define NJ_FUNC_NJ_DELETE_WORD                      (0x002F)
#define NJ_FUNC_NJ_CHECK_DIC                        (0x0030)
#define NJ_FUNC_NJD_L_MAKE_SPACE                    (0x0053)
#define NJ_FUNC_SEARCH_RANGE_BY_YOMI_MULTI          (0x0054)
#define NJ_FUNC_NJD_L_GET_RELATIONAL_WORD           (0x0055)
#define NJ_FUNC_QUE_STRCMP_INCLUDE                  (0x0056)
#define NJ_FUNC_IS_CONTINUED                        (0x0057)
#define NJ_FUNC_CONTINUE_CNT                        (0x0058)
#define NJ_FUNC_NJD_GET_ADDITIONAL_INFO             (0x0095)

#define NJ_FUNC_NJC_CONV                            (0x0031)
#define NJ_FUNC_NJC_ZENKOUHO                        (0x0032)
#define NJ_FUNC_NJC_ZENKOUHO1                       (0x0033)
#define NJ_FUNC_NJC_TOP_CONV                        (0x0034)
#define NJ_FUNC_NJC_GET_STROKE                      (0x0035)
#define NJ_FUNC_NJC_GET_CANDIDATE                   (0x0036)
#define NJ_FUNC_NJC_GET_GIJI_RESULT                 (0x0037)
#define NJ_FUNC_NJ_CHANGE_DIC_TYPE                  (0x0076)
#define NJ_FUNC_NJ_GET_EXT_AREA_SIZE                (0x0039)
#define NJ_FUNC_NJ_INIT_EXT_AREA                    (0x003A)
#define NJ_FUNC_NJ_CHECK_EXT_AREA                   (0x003B)
#define NJ_FUNC_SEARCH_WORD                         (0x003C)
#define NJ_FUNC_NJ_CHECK_ADD_INFO                   (0x003D)
#define NJ_FUNC_PROGRAM_DIC_OPERATION               (0x0090)
#define NJ_FUNC_NJ_GET_FLASH_DIC_CACHE_SIZE         (0x009B)
#define NJ_FUNC_NJ_SET_FLASH_DIC_INFO               (0x009C)

/* Common block API interface */
#define NJ_FUNC_NJ_SELECT                           (0x0040)
#define NJ_FUNC_NJ_INIT                             (0x0041)
#define NJ_FUNC_NJ_GET_CANDIDATE                    (0x0042)
#define NJ_FUNC_NJ_GET_STROKE                       (0x0043)
#define NJ_FUNC_NJ_GET_CHAR_TYPE                    (0x0074)
#define NJ_FUNC_NJ_GET_GIJI                         (0x0075)
#define NJ_FUNC_NJ_UNDO                             (0x0079)
#define NJ_FUNC_NJ_SET_GIJISET                      (0x0077)
#define NJ_FUNC_NJ_SET_OPTION                       (0x0083)
#define NJ_FUNC_NJ_SET_STATE                        (0x0086)
#define NJ_FUNC_NJ_GET_STATE                        (0x0087)
#define NJ_FUNC_NJ_GET_WORD_INFO                    (0x008D)
#define NJ_FUNC_NJ_MERGE_WORD_LIST                  (0x008E)
#define NJ_FUNC_NJ_GET_ADD_INFO                     (0x009A)

/* Evaluation block API interface */
#define NJ_FUNC_NJ_ANALYZE                          (0x0050)
#define NJ_FUNC_ANALYZE_BODY                        (0x0051)
#define NJ_FUNC_ANALYZE_CONVERSION_SINGLE           (0x0052)
#define NJ_FUNC_ANALYZE_MODE_CHANGE                 (0x0084)

/* Common block nehomonym.c */
#define NJ_FUNC_NJE_APPEND_HOMONYM                  (0x0060)
#define NJ_FUNC_NJ_MANAGE_LEARNDIC                  (0x0093)

#define NJ_FUNC_NJD_OFFSET_FREAD                    (0x009F)



#ifdef __cplusplus 
}
#endif
#endif /* _NJ_ERR_H_ */
