/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     nj_lib.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/
/****************************************************************
 * This environment setting file is critical to providing customer support.

 * If you have questions or revise this file, send this file to OMRON with the following information.

 *   ?E iWnn version name (given at the start of README.txt)
 *   ?E Compile options used
 ****************************************************************/

#define NJ_VERSION "iWnn Version 1.2.6 SmallMemory"

#ifndef _NJ_LIB_H_
#define _NJ_LIB_H_

#include <nn/middleware.h>
#ifdef __cplusplus 
extern "C" {
#endif



/************************************************/
/*              define declarations                  */
/************************************************/
/*
 - Numeral type
 */
#ifdef _IWNN_CTR_MODE
#include <nn/types.h>
#else
typedef signed char    s8;
typedef unsigned char  u8;
typedef signed short   s16;
typedef unsigned short u16;
typedef signed long    s32;
typedef unsigned long  u32;
typedef unsigned short wchar_t; (#ifdef NJ_OPT_UTF16̏ꍇj
#endif

/* Please see man pages for details 
 
 */
typedef void NJ_FILE;

/* Please see man pages for details 
 
 */
#ifdef NJ_OPT_UTF16
#define NJ_CHAR_NUL  0x0000
#else /* NJ_OPT_UTF16 */
#define NJ_CHAR_NUL  ('\0')
#endif /* NJ_OPT_UTF16 */

/* Please see man pages for details 
 
 */
#define NJ_TERM_LEN  1
#define NJ_TERM_SIZE (NJ_TERM_LEN)

/* Please see man pages for details 
 
 */
#ifndef NULL
#define NULL 0
#endif


#ifdef NJ_OPT_UTF16
/*
 * Definition of the character code assigned to "?`" (only when using UTF-16)
 */
/* [UTF16] Character code definition for the double-byte "?`" character. */
#ifndef NJ_CHAR_WAVE_DASH_BIG
/*#define NJ_CHAR_WAVE_DASH_BIG   0x301C*/  /* Please see man pages for details */
#define NJ_CHAR_WAVE_DASH_BIG   0xFF5E /* Please see man pages for details */
#endif /* NJ_CHAR_WAVE_DASH_BIG */
/* [UTF16] Character code definition for the single-byte "~" character. */
#ifndef NJ_CHAR_WAVE_DASH_SMALL
/*#define NJ_CHAR_WAVE_DASH_SMALL 0x203E*/  /* Please see man pages for details */
#define NJ_CHAR_WAVE_DASH_SMALL 0x007E /* Please see man pages for details */
#endif /* NJ_CHAR_WAVE_DASH_SMALL */
#endif /* NJ_OPT_UTF16 */

/*
 * Common dictionary definitions (cannot be modified)
 */
/* Please see man pages for details */
#define NJ_INDEX_SIZE      2

/*
 * Common dictionary definitions
 */
/* Please see man pages for details */
#define NJ_LEARN_DIC_HEADER_SIZE   72

/*
 * Data types limited to within the engine
 */
typedef s16 NJ_HINDO;      /* Please see man pages for details */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_DIC
#define NJ_MAX_DIC 20
#endif /* NJ_MAX_DIC */

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_MAX_CHARSET
#define NJ_MAX_CHARSET 50
#endif /* NJ_MAX_CHARSET */

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_SEARCH_CACHE_SIZE
#define NJ_SEARCH_CACHE_SIZE   50
#endif /* NJ_SEARCH_CACHE_SIZE */

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_CACHE_VIEW_CNT
#define NJ_CACHE_VIEW_CNT       2
#endif /* NJ_CACHE_VIEW_CNT */


/* Please see man pages for details 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_RESULT_LEN
#define NJ_MAX_RESULT_LEN  40
#endif /* NJ_MAX_RESULT_LEN */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_LEN
#define NJ_MAX_LEN          40
#endif /* NJ_MAX_LEN */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_ADDITIONAL_LEN
#define NJ_MAX_ADDITIONAL_LEN          40
#endif /* NJ_MAX_ADDITIONAL_LEN */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_ADDITIONAL_INFO
#define NJ_MAX_ADDITIONAL_INFO         2
#endif /* NJ_MAX_ADDITIONAL_INFO */


/* Please see man pages for details 
 
 
 
 */
#ifndef NJ_MAX_KEYWORD
#define NJ_MAX_KEYWORD (NJ_MAX_RESULT_LEN + NJ_TERM_LEN)
#endif /* NJ_MAX_KEYWORD */

/* Please see man pages for details 
 
 
 
 */
#ifndef NJ_MAX_PHRASE
#define NJ_MAX_PHRASE       NJ_MAX_LEN
#endif /* NJ_MAX_PHRASE */

/* Please see man pages for details 
 
 
 
 */
#ifndef NJ_MAX_PHR_CONNECT
#define NJ_MAX_PHR_CONNECT      5
#endif /* NJ_MAX_PHR_CONNECT */


/* Please see man pages for details 
 
 
 
 */
#ifndef NJ_MAX_RELATION_SEGMENT
#define NJ_MAX_RELATION_SEGMENT      5
#endif /* NJ_MAX_RELATION_SEGMENT */

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_MAX_FZK_LEN
#define NJ_MAX_FZK_LEN  (NJ_MAX_LEN / 2)
#endif /* NJ_MAX_FZK_LEN */

/* Please see man pages for details 
 
 
 
 
 */
#ifndef NJ_MAX_FZK_CANDIDATE
#define NJ_MAX_FZK_CANDIDATE    NJ_MAX_LEN
#endif /* NJ_MAX_FZK_CANDIDATE */

/* Please see man pages for details 
 
 
 */
#ifndef NJ_MAX_RELATION_RESULTS
#define NJ_MAX_RELATION_RESULTS 50
#endif /* NJ_MAX_RELATION_RESULTS */
 

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_MAX_GET_RESULTS
#define NJ_MAX_GET_RESULTS 32
#endif /* NJ_MAX_GET_RESULTS */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_USER_LEN
#define NJ_MAX_USER_LEN         40
#endif /* NJ_MAX_USER_LEN */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_USER_KOUHO_LEN
#define NJ_MAX_USER_KOUHO_LEN   40
#endif /* NJ_MAX_USER_KOUHO_LEN */

/* Please see man pages for details 
 
 
 
 
 
 
 
 
 */
#ifndef NJ_MAX_USER_ADDITIONAL_LEN
#define NJ_MAX_USER_ADDITIONAL_LEN   40
#endif /* NJ_MAX_USER_ADDITIONAL_LEN */

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_MAX_USER_COUNT
#define NJ_MAX_USER_COUNT       100
#endif /* NJ_MAX_USER_COUNT */

/* Please see man pages for details 
 
 
 
 */
#define NJ_USER_QUE_SIZE        (((NJ_MAX_USER_LEN + NJ_MAX_USER_KOUHO_LEN) * sizeof(wchar_t)) + 5)
#define NJ_USER_DIC_SIZE        ((NJ_USER_QUE_SIZE + NJ_INDEX_SIZE + NJ_INDEX_SIZE) * NJ_MAX_USER_COUNT + NJ_INDEX_SIZE  + NJ_INDEX_SIZE + NJ_LEARN_DIC_HEADER_SIZE + 4)

/* Please see man pages for details 
 
 
 
 */
#define NJ_USER2_QUE_SIZE        (((NJ_MAX_USER_LEN + NJ_MAX_USER_KOUHO_LEN + NJ_MAX_ADDITIONAL_LEN) * sizeof(wchar_t)) + 7)
#define NJ_USER2_DIC_SIZE        ((NJ_USER2_QUE_SIZE + NJ_INDEX_SIZE + NJ_INDEX_SIZE) * NJ_MAX_USER_COUNT + NJ_INDEX_SIZE  + NJ_INDEX_SIZE + NJ_LEARN_DIC_HEADER_SIZE + 4)

/* Please see man pages for details 
 
 
 
 
 
 */
#ifndef NJ_MAX_CANDIDATE
#define NJ_MAX_CANDIDATE        300
#endif /* NJ_MAX_CANDIDATE */

/* Please see man pages for details 
 
 
 
 
 
 
 
 */
#ifndef MM_MAX_MORPHO_LEN
#define MM_MAX_MORPHO_LEN  (100 / sizeof(wchar_t))
#endif /* MM_MAX_MORPHO_LEN */

/************************************************/
/*              structure declarations               */
/************************************************/
/* Please see man pages for details 
 
 */
typedef u8 * NJ_DIC_HANDLE;

/* Please see man pages for details 
 
 */
typedef struct {
    u16 base;         /* Please see man pages for details */
    u16 high;         /* Please see man pages for details */
} NJ_DIC_FREQ;

/* Please see man pages for details 
 
 */
typedef struct {
    u32  current;     /* Please see man pages for details */
    u32  top;         /* Please see man pages for details */
    u32  bottom;      /* Please see man pages for details */
    u8  *node;        /* Please see man pages for details */
    u8  *now;         /* Please see man pages for details */
    u16  idx_no;      /* Please see man pages for details */
    NN_PADDING2;
} NJ_CACHE_INFO;

/* Please see man pages for details 
 
 */
typedef struct {
    u8      statusFlg;                        /* Please see man pages for details */
#define NJ_STATUSFLG_CACHEOVER ((u8)0x01)     /* Please see man pages for details */
#define NJ_STATUSFLG_AIMAI     ((u8)0x02)     /* Please see man pages for details */
#define NJ_STATUSFLG_HINDO     ((u8)0x04)     /* Please see man pages for details */
    u8      viewCnt;                          /* Please see man pages for details */
    NN_PADDING2;
    u16     keyPtr[NJ_MAX_KEYWORD];           /* Please see man pages for details */
    NJ_CACHE_INFO storebuff[NJ_SEARCH_CACHE_SIZE];  /* Please see man pages for details */
} NJ_SEARCH_CACHE;

/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_GET_CACHEOVER_FROM_SCACHE(s) ((s)->statusFlg & NJ_STATUSFLG_CACHEOVER)
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_GET_AIMAI_FROM_SCACHE(s)     ((s)->statusFlg & NJ_STATUSFLG_AIMAI)
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_SET_CACHEOVER_TO_SCACHE(s)   ((s)->statusFlg |= NJ_STATUSFLG_CACHEOVER)
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_SET_AIMAI_TO_SCACHE(s)       ((s)->statusFlg |= NJ_STATUSFLG_AIMAI)
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_UNSET_CACHEOVER_TO_SCACHE(s) ((s)->statusFlg &= ~NJ_STATUSFLG_CACHEOVER) 
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_UNSET_AIMAI_TO_SCACHE(s)     ((s)->statusFlg &= ~NJ_STATUSFLG_AIMAI)


/* Please see man pages for details 
 
 */
typedef struct {
    u32     dictype;                            /* Please see man pages for details */
    u32     dicsize;                            /* Please see man pages for details */
    u32     mode;                               /* Please see man pages for details */
    NJ_FILE *     filestream;                         /* Please see man pages for details */
#define NJ_FLASH_DIC_CACHE_MAX 11                     /* Please see man pages for details */
#define NJ_FLASH_DIC_HEAD       0                     /* Please see man pages for details */
    void *     cache_area[NJ_FLASH_DIC_CACHE_MAX]; /* Please see man pages for details */
    void *     extension_data;                     /* Please see man pages for details */
} NJ_FLASH_DIC_INFO;

/* Please see man pages for details 
 
 */
typedef struct {
    u8            type;           /* Please see man pages for details */
#define NJ_DIC_H_TYPE_NORMAL   0x00     /* Please see man pages for details */
#define NJ_DIC_H_TYPE_PROGRAM  0x01     /* Please see man pages for details */
#define NJ_DIC_H_TYPE_PROGRAM_FZK 0x02  /* Please see man pages for details */
#define NJ_DIC_H_TYPE_ON_FLASH 0x03     /* Please see man pages for details */
    u8            limit;          /* Please see man pages for details */

    NN_PADDING2;
    NJ_DIC_HANDLE       handle;         /* Please see man pages for details */
    void *           ext_area;       /* Please see man pages for details */
    void *           add_info[NJ_MAX_ADDITIONAL_INFO]; /* Please see man pages for details */

#define NJ_MODE_TYPE_MAX  3  /* Please see man pages for details */ 
    /* Please see man pages for details */
    NJ_DIC_FREQ         dic_freq[NJ_MODE_TYPE_MAX];
#define NJ_MODE_TYPE_HENKAN  0  /* Please see man pages for details */ 
#define NJ_MODE_TYPE_YOSOKU  1  /* Please see man pages for details */ 
#define NJ_MODE_TYPE_MORPHO  2  /* Please see man pages for details */ 

    NJ_SEARCH_CACHE *   srhCache;       /* Please see man pages for details */
} NJ_DIC_INFO;

/* Please see man pages for details 
 
 */
#define NJ_DEFAULT_FREQ_DIC_UBASE_H_HIGH    550 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_UBASE_H_BASE    400 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_UBASE_Y_HIGH    560 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_UBASE_Y_BASE    100 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_UBASE_M_HIGH    500 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_UBASE_M_BASE    400 /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_TAN_H_HIGH      10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_TAN_H_BASE      0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_TAN_Y_HIGH      0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_TAN_Y_BASE      10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_TAN_M_HIGH      10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_TAN_M_BASE      0   /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_FZK_H_HIGH      500 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_FZK_H_BASE      400 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_FZK_Y_HIGH      0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_FZK_Y_BASE      10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_FZK_M_HIGH      500 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_FZK_M_BASE      400 /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_YOMI_H_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_YOMI_H_BASE     10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_YOMI_Y_HIGH     244 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_YOMI_Y_BASE     100 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_YOMI_M_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_YOMI_M_BASE     10  /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_H_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_H_BASE     10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_Y_HIGH     920 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_Y_BASE     820 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_M_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_HEAD_YOMI_M_BASE     10  /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_H_HIGH 0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_H_BASE 10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_Y_HIGH 244 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_Y_BASE 100 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_M_HIGH 0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_EXT_YOMI_M_BASE 10  /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_USER_H_HIGH     410 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_USER_H_BASE     410 /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_USER_Y_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_USER_Y_BASE     10  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_USER_M_HIGH     0   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_USER_M_BASE     10  /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_LEARN_H_HIGH    1000    /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LEARN_H_BASE    501     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LEARN_Y_HIGH    1000    /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LEARN_Y_BASE    501     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LEARN_M_HIGH    0       /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LEARN_M_BASE    10      /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_PRORAM_H_HIGH    0      /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_PRORAM_H_BASE    0      /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_PRORAM_Y_HIGH    0      /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_PRORAM_Y_BASE    10     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_PRORAM_M_HIGH    0      /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_PRORAM_M_BASE    10     /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_H_HIGH    0     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_H_BASE    10    /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_Y_HIGH    1000  /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_Y_BASE    950   /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_M_HIGH    0     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_LIMIT_PRED_PRORAM_M_BASE    10    /* Please see man pages for details */

#define NJ_DEFAULT_FREQ_DIC_CUSTOM_H_HIGH   400     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_CUSTOM_H_BASE   0       /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_CUSTOM_Y_HIGH   400     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_CUSTOM_Y_BASE   0       /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_CUSTOM_M_HIGH   400     /* Please see man pages for details */
#define NJ_DEFAULT_FREQ_DIC_CUSTOM_M_BASE   0       /* Please see man pages for details */


/* Please see man pages for details 
 
 */
typedef struct {
    NJ_DIC_INFO   dic[NJ_MAX_DIC];           /* Please see man pages for details */
    NJ_DIC_HANDLE  rHandle[NJ_MODE_TYPE_MAX]; /* Rule dictionary mount region */

    /* Please see man pages for details */
    u16           mode;
#define NJ_CACHE_MODE_NONE          0x0000   /* Please see man pages for details */ 
#define NJ_CACHE_MODE_VALID         0x0001   /* Please see man pages for details */ 
#define NJ_CACHE_MODE_VALID_FUSION  0x0002   /* Please see man pages for details 
                                                  */ 
    NN_PADDING2;
    /* Please see man pages for details */
    wchar_t             keyword[NJ_MAX_KEYWORD];
} NJ_DIC_SET;

/* Please see man pages for details 
 
 */
typedef struct {
    u16  charset_count;               /* Please see man pages for details */
    NN_PADDING2;
    wchar_t    *from[NJ_MAX_CHARSET];       /* Please see man pages for details */
    wchar_t    *to[NJ_MAX_CHARSET];         /* Please see man pages for details */
} NJ_CHARSET;


/* Please see man pages for details 
 
 */
typedef struct {

    u8 operation;          /* Please see man pages for details */
#define NJ_CUR_OP_COMP      0    /* Please see man pages for details */
#define NJ_CUR_OP_FORE      1    /* Please see man pages for details */
#define NJ_CUR_OP_LINK      2    /* Please see man pages for details */
#define NJ_CUR_OP_REV       3    /* Please see man pages for details */
#define NJ_CUR_OP_REV_FORE  4    /* Please see man pages for details */

    u8 mode;               /* Please see man pages for details */
#define NJ_CUR_MODE_FREQ    0    /* Please see man pages for details */
#define NJ_CUR_MODE_YOMI    1    /* Please see man pages for details */
#define NJ_CUR_MODE_REGIST  2    /* Please see man pages for details */


    NN_PADDING2;
    NJ_DIC_SET *ds;              /* Please see man pages for details */

    /* Please see man pages for details 
     
     */
    struct {
        u8 *fore;          /* Please see man pages for details */
        u16 foreSize;      /* Please see man pages for details */
        u16 foreFlag;      /* Please see man pages for details */
        u8 *rear;          /* Please see man pages for details */
        u16 rearSize;      /* Please see man pages for details */
        u16 rearFlag;      /* Please see man pages for details */
        u8 *yominasi_fore; /* Please see man pages for details */
        u16 prev_bpos;     /* Please see man pages for details */
        NN_PADDING2;
    } hinsi;

    wchar_t  *yomi;       /* Please see man pages for details 
                               */
    u16 ylen;       /* Please see man pages for details */
    u16 yclen;      /* Please see man pages for details */
    wchar_t  *kanji;      /* Please see man pages for details 
                               */
    NJ_CHARSET *charset;  /* Please see man pages for details */

    u8   fzkconnect;   /* Ancillary word connection yes/no */
    u8   ctrl_opt;   /* [Internal Use] */
/* Please see man pages for details */ 
#define NJ_SEARCH_DISMANTLING_CONTROL 0x80
    NN_PADDING2;
} NJ_SEARCH_CONDITION;

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_DIC_HANDLE  handle;        /* Please see man pages for details */
    void *      ext_area;      /* Please see man pages for details */
    void *      add_info[NJ_MAX_ADDITIONAL_INFO]; /* Please see man pages for details */
    u32      current;       /* Please see man pages for details */
    u32      top;           /* Please see man pages for details */
    u32      bottom;        /* Please see man pages for details */
    u32      relation[NJ_MAX_PHR_CONNECT];   /* Head position */
    u32      attr;         /* Please see man pages for details */
    u16      current_cache; /* Please see man pages for details */
    u8       current_info;  /* Number of joined phrases   */
    u8       status;   /* Search status */    
    u8       type;     /* Please see man pages for details */
    NN_PADDING3;
} NJ_SEARCH_LOCATION;

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_HINDO           cache_freq;   /* Please see man pages for details */
    NN_PADDING2;
    NJ_DIC_FREQ        dic_freq;     /* Please see man pages for details */
    s16           dic_freq_max; /* Please see man pages for details */
    s16           dic_freq_min; /* Please see man pages for details */
    NJ_SEARCH_LOCATION loct;         /* Please see man pages for details */
} NJ_SEARCH_LOCATION_SET;

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_SEARCH_CONDITION cond;                   /* Please see man pages for details */
    NJ_SEARCH_LOCATION_SET loctset[NJ_MAX_DIC]; /* Please see man pages for details */
} NJ_CURSOR;

/* Please see man pages for details 
 
 */
typedef struct {
    u8 hinsi_group;          /* Please see man pages for details */
#define NJ_HINSI_MEISI          0    /* Please see man pages for details */
#define NJ_HINSI_JINMEI         1    /* Please see man pages for details */
#define NJ_HINSI_MEISI_NO_CONJ  2    /* Please see man pages for details */
#define NJ_HINSI_CHIMEI         2    /* Please see man pages for details */
#define NJ_HINSI_KIGOU          3    /* Please see man pages for details */
#define NJ_HINSI_DETAIL         255  /* Please see man pages for details */
    NN_PADDING3;

    wchar_t  yomi[NJ_MAX_LEN + NJ_TERM_LEN];         /* Please see man pages for details */
    wchar_t  kouho[NJ_MAX_RESULT_LEN + NJ_TERM_LEN]; /* Please see man pages for details */
    wchar_t  additional[NJ_MAX_ADDITIONAL_LEN + NJ_TERM_LEN]; /* Please see man pages for details */

    /* Please see man pages for details */
    struct {
        u16  yomi_len;    /* Please see man pages for details */
        u16  kouho_len;   /* Please see man pages for details */
        u32  hinsi;       /* Please see man pages for details */
        u32  attr;        /* Please see man pages for details */
        s16   freq;        /* Please see man pages for details */
        NN_PADDING2;
    } stem;

    /* Please see man pages for details */
    struct {
        u16  yomi_len;    /* Please see man pages for details */
        u16  kouho_len;   /* Please see man pages for details */
        u32  hinsi;       /* Please see man pages for details */
        s16   freq;        /* Please see man pages for details */
        NN_PADDING2;
    } fzk;

    s16   connect;         /* Please see man pages for details */
    NN_PADDING2;

} NJ_WORD_INFO;

typedef struct {
    u16  info1;       /* Please see man pages for details */
    u16  info2;       /* Please see man pages for details */
    NJ_HINDO   hindo;       /* Please see man pages for details */
    NN_PADDING2;
} NJ_FZK; 

/* Please see man pages for details 
 
 */
typedef struct {
    wchar_t  *yomi;   /* Please see man pages for details */

    /* Please see man pages for details */
    struct NJ_STEM {
        u16  info1;       /* Please see man pages for details */
        u16  info2;       /* Please see man pages for details */
        NJ_HINDO   hindo;       /* Please see man pages for details */
        NN_PADDING2;
        NJ_SEARCH_LOCATION loc; /* Please see man pages for details */
        u8   type;        /* Please see man pages for details */
       NN_PADDING3;
    } stem;

    NJ_FZK fzk;
    
} NJ_WORD;

/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_FPOS_FROM_STEM(s) ((u16)((s)->stem.info1 >> 7))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_YLEN_FROM_STEM(s) ((u8)((s)->stem.info1 & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_BPOS_FROM_STEM(s) ((u16)((s)->stem.info2 >> 7))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_KLEN_FROM_STEM(s) ((u8)((s)->stem.info2 & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_FREQ_FROM_STEM(s) ((s16)((s)->stem.hindo))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_TYPE_FROM_STEM(s) ((s)->stem.type)
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_FPOS_TO_STEM(s,v) ((s)->stem.info1 = ((s)->stem.info1 & 0x007F) | (u16)((v) << 7))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_YLEN_TO_STEM(s,v) ((s)->stem.info1 = ((s)->stem.info1 & 0xFF80) | (u16)((v) & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_BPOS_TO_STEM(s,v) ((s)->stem.info2 = ((s)->stem.info2 & 0x007F) | (u16)((v) << 7))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_KLEN_TO_STEM(s,v) ((s)->stem.info2 = ((s)->stem.info2 & 0xFF80) | (u16)((v) & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_FREQ_TO_STEM(s,v) ((s)->stem.hindo = (NJ_HINDO)(v))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_TYPE_TO_STEM(s,v) ((s)->stem.type = (v))

/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_FPOS_FROM_FZK(f) ((u16)((f)->fzk.info1 >> 7))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_YLEN_FROM_FZK(f) ((u8)((f)->fzk.info1 & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_BPOS_FROM_FZK(f) ((u16)((f)->fzk.info2 >> 7))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_KLEN_FROM_FZK(f) ((u8)((f)->fzk.info2 & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 */
#define NJ_GET_FREQ_FROM_FZK(f) ((f)->fzk.hindo)
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_FPOS_TO_FZK(s,v) ((s)->fzk.info1 = ((s)->fzk.info1 & 0x007F) | (u16)((v) << 7))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_YLEN_TO_FZK(s,v) ((s)->fzk.info1 = ((s)->fzk.info1 & 0xFF80) | (u16)((v) & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_BPOS_TO_FZK(s,v) ((s)->fzk.info2 = ((s)->fzk.info2 & 0x007F) | (u16)((v) << 7))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_KLEN_TO_FZK(s,v) ((s)->fzk.info2 = ((s)->fzk.info2 & 0xFF80) | (u16)((v) & 0x7F))
/* Please see man pages for details 
 
 
 
 
 
 
 */
#define NJ_SET_FREQ_TO_FZK(s,v) ((s)->fzk.hindo = (NJ_HINDO)(v))


/* Please see man pages for details 
 
 */
typedef struct {
    /* Please see man pages for details */
    u16 operation_id;
#define NJ_OP_MASK          0x000f  /* Please see man pages for details */
    /* Please see man pages for details 
     
     
     
     
     
     */
#define NJ_GET_RESULT_OP(id) ((id) & NJ_OP_MASK)
#define NJ_OP_SEARCH        0x0000  /* Please see man pages for details */
#define NJ_OP_CONVERT       0x0001  /* Please see man pages for details */
#define NJ_OP_ANALYZE       0x0002  /* Please see man pages for details */
#define NJ_OP_MORPHOLIZE    0x0003  /* Please see man pages for details */
#define NJ_OP_ENV           0x0004  /* Please see man pages for details */

#define NJ_FUNC_MASK        0x00f0  /* Please see man pages for details */
    /* Please see man pages for details 
     
     
     
     
     
     */
#define NJ_GET_RESULT_FUNC(id) ((id) & NJ_FUNC_MASK)
#define NJ_FUNC_SEARCH              0x0000  /* Please see man pages for details */
#define NJ_FUNC_CONVERT_MULTIPLE    0x0010  /* Please see man pages for details */
#define NJ_FUNC_CONVERT_SINGLE      0x0020  /* Please see man pages for details */
#define NJ_FUNC_ZENKOUHO            0x0030  /* Please see man pages for details */
#define NJ_FUNC_NEXT                0x0040  /* Please see man pages for details */
#define NJ_FUNC_SEARCH_R            0x0050  /* Please see man pages for details */
#define NJ_FUNC_SPLIT_WORD          0x0060  /* Please see man pages for details */
#define NJ_FUNC_GET_GIJI            0x0070  /* Please see man pages for details */
#define NJ_FUNC_RELATION            0x0080  /* Please see man pages for details */

#define NJ_TYPE_GIJI_MASK           0x0800  /* Please see man pages for details */
    /* Please see man pages for details 
     
     
     
     
     
     */
#define NJ_GET_GIJI_BIT(id) ((id) & NJ_TYPE_GIJI_MASK)
#define NJ_TYPE_GIJI_BIT            0x0800  /* Please see man pages for details */
#define NJ_TYPE_UNUSED_MASK         0x0700  /* Please see man pages for details */
#define NJ_TYPE_MERGE_TMP_BIT       0x0400  /* Please see man pages for details */

#define NJ_DIC_MASK                 0xf000  /* Please see man pages for details */
    /* Please see man pages for details 
     
     
     
     
     
     */
#define NJ_GET_RESULT_DIC(id) ((id) & 0xF000)
#define NJ_DIC_GIJI                 0x0000  /* Please see man pages for details */
#define NJ_DIC_STATIC               0x1000  /* Please see man pages for details */
#define NJ_DIC_CUSTOMIZE            0x2000  /* Please see man pages for details */
#define NJ_DIC_LEARN                0x3000  /* Please see man pages for details */
#define NJ_DIC_USER                 0x4000  /* Please see man pages for details */
#define NJ_DIC_PROGRAM              0x5000  /* Please see man pages for details */

    NN_PADDING2;
    /* Please see man pages for details */
    NJ_WORD word;
} NJ_RESULT;

/* Please see man pages for details 
 
 */
typedef struct {
    u16  autoconv_cnt;      /* Please see man pages for details */
    /* Please see man pages for details */
#define NJ_OPT_AUTOCONV_CNT       NJ_MAX_CANDIDATE
    u16  ext_mode;            /* Please see man pages for details */
#define NJ_ADD_WORD_OPTIMIZE_OFF    0x0001  /* Please see man pages for details */
#define NJ_OPT_FORECAST_TOP_FREQ     0x0002  /* Please see man pages for details */
    void *  phase2_filter;       /* Please see man pages for details */
    void *  phase2_option;       /* Please see man pages for details */
    void *  phase1_filter;       /* Please see man pages for details */
    void *  phase1_option;       /* Please see man pages for details */
} NJ_OPTION;


/*
 * nj_analyze function parsing limit type
 */
#define NJ_NO_RENBUN            (u16)0x0001 /* Please see man pages for details */
#define NJ_NO_TANBUN            (u16)0x0002 /* Please see man pages for details */
#define NJ_NO_CLEAR_LEARN_CACHE (u16)0x0004 /* Please see man pages for details */
#define NJ_NO_LEARN             (u16)0x0008 /* Please see man pages for details */
#define NJ_NO_YOSOKU            (u16)0x0010 /* Please see man pages for details */
#define NJ_NO_ZEN               (u16)0x0020 /* Please see man pages for details */
#define NJ_YOMINASI_ON          (u16)0x0100 /* Please see man pages for details */
#define NJ_RELATION_ON          (u16)0x0200 /* Please see man pages for details */

/* Please see man pages for details 
 
 */
typedef struct {
    u16  mode;                            /* Please see man pages for details */
#define NJ_DEFAULT_MODE (NJ_NO_RENBUN|NJ_NO_TANBUN|NJ_RELATION_ON|NJ_YOMINASI_ON)/* Please see man pages for details */
    u16  forecast_learn_limit;            /* Please see man pages for details */
#define NJ_DEFAULT_FORECAST_LEARN_LIMIT 30      /* Please see man pages for details */
    u16  forecast_limit;                  /* Please see man pages for details */
#define NJ_DEFAULT_FORECAST_LIMIT 100           /* Please see man pages for details */
    NN_PADDING2;

    u8   char_min;                        /* Please see man pages for details */
#define NJ_DEFAULT_CHAR_MIN 0                   /* Please see man pages for details */
    u8   char_max;                        /* Please see man pages for details */
#define NJ_DEFAULT_CHAR_MAX NJ_MAX_LEN          /* Please see man pages for details */
    NN_PADDING2;
} NJ_ANALYZE_OPTION;

#ifdef NJ_OPT_STATE_TYPE2
#define NJ_MAX_STATE 32                  /* Please see man pages for details */
#else /* NJ_OPT_STATE_TYPE2 */
#define NJ_MAX_STATE 16                  /* Please see man pages for details */
#endif /* NJ_OPT_STATE_TYPE2 */

/* Please see man pages for details 
 
 */
typedef struct {
    s16 system_max_bias[NJ_MAX_STATE];                 /* Please see man pages for details */
    s16 system_min_bias[NJ_MAX_STATE];                 /* Please see man pages for details */
    s16 system_add_bias[NJ_MAX_STATE];                 /* Please see man pages for details */
    s16 system_base_bias[NJ_MAX_STATE];                /* Please see man pages for details */
    s16 system_change_bias[NJ_MAX_STATE][NJ_MAX_STATE];/* Please see man pages for details */
    s16 dicinfo_max[NJ_MAX_DIC];                       /* Please see man pages for details */
    s16 dicinfo_min[NJ_MAX_DIC];                       /* Please see man pages for details */
} NJ_STATE_CALC_PARAMETER;
#define NJ_STATE_MAX_FREQ  1000         /* Please see man pages for details */
#define NJ_STATE_MIN_FREQ     0         /* Please see man pages for details */

/* Please see man pages for details 
 
 */
typedef struct {
    s16 system[NJ_MAX_STATE];        /* Please see man pages for details */
#ifndef NJ_OPT_STATE_TYPE2
#define NJ_CAT_FIELD_PERSON             0 /* Please see man pages for details */
#define NJ_CAT_FIELD_NOUN               1 /* Please see man pages for details */
#define NJ_CAT_FIELD_HEAD               2 /* Please see man pages for details */
#define NJ_CAT_EXPRESSION_COLLOQUIAL    3 /* Please see man pages for details */
#define NJ_CAT_EXPRESSION_WRITTEN       4 /* Please see man pages for details */
#define NJ_CAT_TIME_MORNING             5 /* Please see man pages for details */
#define NJ_CAT_TIME_NOON                6 /* Please see man pages for details */
#define NJ_CAT_TIME_NIGHT               7 /* Please see man pages for details */
#define NJ_CAT_TIME_SPRING              8 /* Please see man pages for details */
#define NJ_CAT_TIME_SUMMER              9 /* Please see man pages for details */
#define NJ_CAT_TIME_AUTUMN              10/* Please see man pages for details */
#define NJ_CAT_TIME_WINTER              11/* Please see man pages for details */
#define NJ_CAT_TIME_PAST                12/* Please see man pages for details */
#define NJ_CAT_TIME_FUTURE              13/* Please see man pages for details */
#define NJ_CAT_FEEL_PLUS                14/* Please see man pages for details */
#define NJ_CAT_FEEL_MINUS               15/* Please see man pages for details */
#else /* !NJ_OPT_STATE_TYPE2 */
#define NJ_CAT_FIELD_PERSON             0 /* Please see man pages for details */
#define NJ_CAT_FIELD_NOUN               1 /* Please see man pages for details */
#define NJ_CAT_FIELD_HEAD               2 /* Please see man pages for details */
#define NJ_CAT_EXPRESSION_COLLOQUIAL    3 /* Please see man pages for details */
#define NJ_CAT_EXPRESSION_WRITTEN       4 /* Please see man pages for details */
#define NJ_CAT_TIME_MORNING             5 /* Please see man pages for details */
#define NJ_CAT_TIME_NOON                6 /* Please see man pages for details */
#define NJ_CAT_TIME_NIGHT               7 /* Please see man pages for details */
#define NJ_CAT_TIME_PAST                8 /* Please see man pages for details */
#define NJ_CAT_TIME_FUTURE              9 /* Please see man pages for details */
#define NJ_CAT_FEEL_PLUS                10/* Please see man pages for details */
#define NJ_CAT_FEEL_MINUS               11/* Please see man pages for details */
#define NJ_CAT_MONTH_JAN                12/* Please see man pages for details */
#define NJ_CAT_MONTH_FEB                13/* Please see man pages for details */
#define NJ_CAT_MONTH_MAR                14/* Please see man pages for details */
#define NJ_CAT_MONTH_APR                15/* Please see man pages for details */
#define NJ_CAT_MONTH_MAY                16/* Please see man pages for details */
#define NJ_CAT_MONTH_JUN                17/* Please see man pages for details */
#define NJ_CAT_MONTH_JUL                18/* Please see man pages for details */
#define NJ_CAT_MONTH_AUG                19/* Please see man pages for details */
#define NJ_CAT_MONTH_SEP                20/* Please see man pages for details */
#define NJ_CAT_MONTH_OCT                21/* Please see man pages for details */
#define NJ_CAT_MONTH_NOV                22/* Please see man pages for details */
#define NJ_CAT_MONTH_DEC                23/* Please see man pages for details */
#endif /* !NJ_OPT_STATE_TYPE2 */

#define NJ_MAX_EXT_STATE 2               /* Please see man pages for details */
    s16 extension[NJ_MAX_EXT_STATE]; /* Please see man pages for details */
    NJ_STATE_CALC_PARAMETER *calc_parameter;
} NJ_STATE;
#define NJ_STATE_MAX_BIAS  1000         /* Please see man pages for details */
#define NJ_STATE_MIN_BIAS  (-1000)      /* Please see man pages for details */

/* Please see man pages for details 
 
 
 
 
 */
/*    Process definitions    */
#define NJ_TYPE_UNDEFINE                 0 /* Please see man pages for details */
#define NJ_TYPE_NONE                     1 /* Please see man pages for details */
/*    Pseudo-candidate type definition    */
#define NJ_TYPE_HIRAGANA                 2 /* Please see man pages for details */
#define NJ_TYPE_KATAKANA                 3 /* Please see man pages for details */
#define NJ_TYPE_HANKATA                  4 /* Please see man pages for details */
#define NJ_TYPE_HAN_SUUJI               11 /* Please see man pages for details */
#define NJ_TYPE_ZEN_SUUJI               12 /* Please see man pages for details */




/*
 * Part of speech group number definitions to be returned by mm_get_hinsi (also used by dtoa)
 * The number of parts of speech groups depends on HGROUP_COUNT.
 */
#define MM_HGROUP_MEISI         0  /* Please see man pages for details */
#define MM_HGROUP_GIJI          1  /* Please see man pages for details */
#define MM_HGROUP_OTHER         2  /* Please see man pages for details */

/*
 * Function for dealing with learning dictionaries
 * Operation definitions
 */
#define NJ_MLD_OP_COMMIT        0  /* Please see man pages for details */
#define NJ_MLD_OP_COMMIT_TO_TOP 1  /* Please see man pages for details */
#define NJ_MLD_OP_COMMIT_CANCEL 2  /* Please see man pages for details */
#define NJ_MLD_OP_GET_SPACE     3  /* Please see man pages for details */
 
#define MM_GET_STEM_LEN(x) ((u16)NJ_GET_YLEN_FROM_STEM(&((x)->word)))


#define MM_GET_CANDIDATE_LEN(x) ((u16)(MM_GET_STEM_LEN(x) + NJ_GET_YLEN_FROM_FZK(&((x)->word))))


/************************************************/
/*            Parsing information class header                 */
/************************************************/
#include "njx_lib.h"
#include "njx_state.h"

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_RESULT *result;  /* Please see man pages for details */
    NJ_CLASS  *iwnn;    /* Please see man pages for details */
} NJ_M_RESULT;

/***********************************************
 * njx_merge_word_list mode definitions
 */
/* Please see man pages for details */
#define NJ_MERGE_INIT  0x0001
/* Please see man pages for details */
#define NJ_MERGE_NOT_EXIST  0x0002
/* Please see man pages for details */
#define NJ_MERGE_NOT_EXIST_FORCE  0x0102
/* Please see man pages for details */
#define NJ_MERGE_FORCE  0x0104


/************************************************/
/*              extern declarations                  */
/************************************************/
/* Please see man pages for details 
 
 */
#define NJ_EXTERN extern
/*
 * (Reference) Change the following declaration if you are creating a Windows DLL.

 * #define NJ_EXTERN extern __declspec(dllexport)
 */


/*
 * Functions for morphological analysis
 */
NJ_EXTERN s16 mmx_split_word(NJ_CLASS *iwnn, wchar_t  *input, u8 *process_len, NJ_RESULT *results);
NJ_EXTERN s16 mmx_get_hinsi(NJ_CLASS *iwnn, NJ_RESULT *result);
NJ_EXTERN s16 mmx_get_yomi(NJ_CLASS *iwnn, NJ_RESULT *result, wchar_t  *yomi, u16 yomi_size, u8 *stem_len);
NJ_EXTERN s16 mmx_select(NJ_CLASS *iwnn, NJ_RESULT *result, wchar_t  *yomi, u8 nofzk, u8 connect);

/*
 * Function for predictive conversion
 */
NJ_EXTERN s16 njx_analyze(NJ_CLASS *iwnn, NJ_CHARSET *charset, wchar_t *yomi, NJ_RESULT *result, NJ_ANALYZE_OPTION *option);

/*
 * Functions for kana conversion
 */
NJ_EXTERN s16 njx_conv(NJ_CLASS *iwnn, wchar_t  *yomi, u8 analyze_level, u8 devide_pos, NJ_RESULT *results);
NJ_EXTERN s16 njx_zenkouho(NJ_CLASS *iwnn, NJ_RESULT *target, u16 candidate_no, NJ_RESULT *result);
NJ_EXTERN s16 njx_get_stroke_word(NJ_CLASS *iwnn, wchar_t *yomi, NJ_RESULT *result);

/*
 * Functions for dictionary lookup
 */
NJ_EXTERN s16 njx_get_stroke(NJ_CLASS *iwnn, NJ_RESULT *result, wchar_t  *buf, u16 buf_size);
NJ_EXTERN s16 njx_get_candidate(NJ_CLASS *iwnn, NJ_RESULT *result, wchar_t  *buf, u16 buf_size);
NJ_EXTERN s16 njx_search_word(NJ_CLASS *iwnn, NJ_CURSOR *cursor);
NJ_EXTERN s16 njx_get_word(NJ_CLASS *iwnn, NJ_CURSOR *cursor, NJ_RESULT *result);
NJ_EXTERN s16 njx_check_dic(NJ_CLASS *iwnn, u8 dic_type, NJ_DIC_HANDLE handle, u8 restore, u32 size);
NJ_EXTERN NJ_DIC_HANDLE njx_get_dic_handle(NJ_CLASS *iwnn, NJ_RESULT *result);
NJ_EXTERN s16 njx_add_word(NJ_CLASS *iwnn, NJ_WORD_INFO *word, u8 type, u8 connect);
NJ_EXTERN s16 njx_delete_word(NJ_CLASS *iwnn, NJ_RESULT *result);
NJ_EXTERN s16 njx_create_dic(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, s8 type, u32 size);
NJ_EXTERN s32 njx_get_additional_info(NJ_CLASS *iwnn, NJ_RESULT *result, s8 index, wchar_t *buf, u32 buf_size);

/*
 * Common functions
 */
NJ_EXTERN s16 njx_set_state(NJ_CLASS *iwnn, NJ_STATE *state);
NJ_EXTERN s16 njx_get_state(NJ_CLASS *iwnn, NJ_STATE *state);
NJ_EXTERN s16 njx_set_option(NJ_CLASS *iwnn, NJ_OPTION *option);
NJ_EXTERN s16 njx_select(NJ_CLASS *iwnn, NJ_RESULT *l_result, NJ_RESULT *r_result, u8 connect);
NJ_EXTERN s16 njx_undo(NJ_CLASS *iwnn, u16 undo_count);
NJ_EXTERN s16 njx_get_char_type(NJ_CLASS *iwnn, NJ_RESULT *result, u8 *stem_type, u8 *fzk_type);
NJ_EXTERN s16 njx_init(NJ_CLASS *iwnn, NJ_OPTION *option);
NJ_EXTERN s16 njx_change_dic_type(NJ_CLASS *iwnn, NJ_DIC_HANDLE handle, u8 direct);
NJ_EXTERN s16 njx_get_ext_area_size(NJ_CLASS *iwnn, u8 dic_type, NJ_DIC_HANDLE handle, u32 *size);
NJ_EXTERN s16 njx_init_ext_area(NJ_CLASS *iwnn, u8 dic_type, NJ_DIC_HANDLE handle, void *ext_area, u32 size);
NJ_EXTERN s16 njx_check_ext_area(NJ_CLASS *iwnn, u8 dic_type, NJ_DIC_HANDLE handle, void *ext_area, u32 size);
NJ_EXTERN s16 njx_check_additional_info(NJ_CLASS *iwnn, u8 dic_type, NJ_DIC_HANDLE handle, void *add_info, u32 size);
NJ_EXTERN s16 njx_merge_word_list(NJ_M_RESULT *word_list, s32 list_max, u32 mode, NJ_CLASS *iwnn, NJ_RESULT *result, s32 num);
NJ_EXTERN s16 njx_get_word_info(NJ_CLASS *iwnn, NJ_RESULT *result, NJ_WORD_INFO *info);
NJ_EXTERN s16 njx_manage_learndic(NJ_CLASS *iwnn, u32 operation);

/*
 * Function for file access
 */

NJ_EXTERN s32 njx_get_flash_dic_cache_size(NJ_CLASS *iwnn, NJ_FILE* filestream);
NJ_EXTERN s32 njx_set_flash_dic_info(NJ_CLASS *iwnn, NJ_FLASH_DIC_INFO *fdicinfo, NJ_FILE* filestream, u8 *cache_area, u32 cache_size);



#ifdef __cplusplus 
}
#endif
#endif /* _NJ_LIB_H_ */
