/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     njc.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/

#ifndef _NJC_H_
#define _NJC_H_

#ifdef __cplusplus 
extern "C" {
#endif
#include <nn/middleware.h>


/************************************************/
/*        Parameter declarations                      */
/************************************************/
#ifndef NJC_MAX_WORK_PHRASE
#define NJC_MAX_WORK_PHRASE 2
#endif /* NJC_MAX_WORK_PHRASE */

#ifndef NJC_MAX_WORK_CANDIDATE
#define NJC_MAX_WORK_CANDIDATE  100
#endif /* NJC_MAX_WORK_CANDIDATE */

#ifndef NJC_MAX_FZK_LEN
#define NJC_MAX_FZK_LEN NJ_MAX_FZK_LEN
#endif /* NJC_MAX_FZK_LEN */

#ifndef NJC_MAX_FZK_CANDIDATE
#define NJC_MAX_FZK_CANDIDATE   NJ_MAX_FZK_CANDIDATE
#endif /* NJC_MAX_FZK_CANDIDATE */

#ifndef NJC_CUTOFF_LENGTH_THRESHOLD
#define NJC_CUTOFF_LENGTH_THRESHOLD 3
#endif /* NJC_CUTOFF_LENGTH_THRESHOLD */

#ifndef NJC_MAX_GET_RESULTS
#define NJC_MAX_GET_RESULTS NJ_MAX_GET_RESULTS
#endif /* NJC_MAX_GET_RESULTS */

#ifndef NJC_PHRASE_COST
#define NJC_PHRASE_COST  (-1000)
#endif /* NJC_PHRASE_COST */

/*
 * njc_mode setting value definition
 */
#define NJC_MODE_NOT_CONVERTED 0        /* Please see man pages for details */
#define NJC_MODE_CONVERTED     1        /* Please see man pages for details */
#define NJC_MODE_ZENKOUHO      2        /* Please see man pages for details */
#define NJC_MODE_MORPHO        3        /* Please see man pages for details */


/************************************************/
/*        Structure declarations                          */
/************************************************/
/* Please see man pages for details 
 
 */
typedef struct {
    wchar_t     *yomi;      /* Please see man pages for details */
    u16   reprLen;    /* Please see man pages for details */
    NN_PADDING2;
    NJ_RESULT   *phrases;   /* Please see man pages for details */
    u16   phrMax;     /* Please see man pages for details */
    u16   phrNum;     /* Please see man pages for details */
} NJC_SENTENCE;

/* Please see man pages for details 
 
 */
typedef struct {
    u16   yomiLen;                      /* Please see man pages for details */
    u16   reprLen;                      /* Please see man pages for details */
    s32    score;                        /* Please see man pages for details */
    NJ_RESULT   phrases[NJC_MAX_WORK_PHRASE]; /* Please see man pages for details */
    u8    phrNum;                       /* Please see man pages for details */
    u8    vphrNum;                      /* Please see man pages for details */
    u8    invalid;                      /* Please see man pages for details 
                                               
                                               */
    NN_PADDING1;
    u8    *connect;                     /* Please see man pages for details */
} NJC_WORK_SENTENCE;


/* Please see man pages for details 
 
 */
typedef struct {
    u16       f_v2;       /* Please see man pages for details */
    u16       f_v1;       /* Please see man pages for details */
    u16       f_v3;       /* Please see man pages for details */
    u16       f_giji;     /* Please see man pages for details */
    u16       r_giji;     /* Please see man pages for details */
    u16       r_ngiji;    /* Please see man pages for details */
    u16       r_bunto;    /* Please see man pages for details */
    u16       fcnt;       /* Please see man pages for details */
    u16       bcnt;       /* Please see man pages for details */
    NN_PADDING2;
} NJC_HINSI_INFO;

/* Please see man pages for details 
 
 */
typedef struct {
    /* Please see man pages for details */
    NJC_WORK_SENTENCE   sentence[NJC_MAX_WORK_CANDIDATE + 1];
    s16            sentNum;            /* Please see man pages for details */
    u16           restYomiLen;        /* Please see man pages for details */
    wchar_t             *pyomi;             /* Please see man pages for details */
    u8            maxRltLen;          /* Please see man pages for details */
    NN_PADDING3;
    NJ_DIC_SET          jds;                /* Please see man pages for details */
    NJ_DIC_SET          fds;                /* Please see man pages for details */
    NJC_HINSI_INFO      hinsi;              /* Please see man pages for details */
    /* Please see man pages for details */
    struct {
        NJ_DIC_SET      *ds;                /* Please see man pages for details */
        u8        nogiji;             /* Please see man pages for details 
                                             
                                             
                                             
                                             */
        u8        top_conv;           /* Please see man pages for details 
                                             
                                             
                                             
                                             */
        u8        level;              /* Please see man pages for details */
        NN_PADDING1;
    } cond;
    u16           flags;              /* Please see man pages for details */
    NN_PADDING2;
} NJC_CONV;

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_CURSOR   *cur;                     /* Please see man pages for details */
    NJ_RESULT   rlt[NJD_MAX_CONNECT_CNT]; /* Please see man pages for details */
    u8    rltcnt;                   /* Please see man pages for details */
    u8    status;                   /* Please see man pages for details */
    NN_PADDING2;
} NJC_CURSOR_LIST;

/* Please see man pages for details 
 
 */
typedef struct {
    u16  info1;   /* Please see man pages for details */
    u16  info2;   /* Please see man pages for details */
    NJ_HINDO   hindo;   /* Please see man pages for details */
} NJC_FZK_RESULT;

/* Please see man pages for details 
 
 */
typedef struct {
    NJC_CURSOR_LIST list[NJ_MAX_LEN]; /* Please see man pages for details */
    u16   listNum;              /* Please see man pages for details */
    NN_PADDING2;
} NJC_CANDIDATE_WORK;

/* Please see man pages for details 
 
 */
typedef struct {
    wchar_t             *yomi;                               /* Please see man pages for details */
    NJC_FZK_RESULT      fzk_phrs[NJC_MAX_FZK_CANDIDATE + 1]; /* Please see man pages for details */
    u16           fzkPhrNum;                           /* Please see man pages for details */
    NN_PADDING2;
    NJC_CANDIDATE_WORK  *jwork;                              /* Please see man pages for details */
    NJ_RESULT           phrases[NJ_MAX_CANDIDATE + 1];       /* Please see man pages for details */
    u16           yomiLen;                             /* Please see man pages for details */
    s16            offset[NJ_MAX_CANDIDATE + 1];        /* Please see man pages for details */
    u16           phrNum;                              /* Please see man pages for details */
    NN_PADDING2;

    NJ_DIC_SET          jds;                                 /* Please see man pages for details */
    NJ_DIC_SET          jds2;                                /* Please see man pages for details */
    NJ_DIC_SET          fds;                                 /* Please see man pages for details */
    NJC_HINSI_INFO          hinsi;                               /* Please see man pages for details */
    /* Please see man pages for details */
    struct {
        NJ_DIC_SET      *ds;                                 /* Please see man pages for details */
        NJ_RESULT       *target;                             /* Please see man pages for details */
        u8        top_set;                             /* Please see man pages for details 
                                                              
                                                              */
        u8        mode;                                /* Please see man pages for details 
                                                              
                                                              
                                                              
                                                              
                                                              
                                                              
                                                              
                                                              */
        NN_PADDING2;
    } cond;
} NJC_CANDIDATE;


/**********************************************************************/


#ifdef __cplusplus 
}
#endif
#endif /* _NJC_H_ */
