/*---------------------------------------------------------------------------*
  Project:  iWnn
  File:     njx_lib.h

  Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
  
 $Revision: $
 *---------------------------------------------------------------------------*/

#ifndef _NJX_LIB_H_
#define _NJX_LIB_H_
#include <nn/middleware.h>

#ifdef __cplusplus 
extern "C" {
#endif


/************************************************/
/*              define declarations                  */
/************************************************/
/* Please see man pages for details */
#define NJ_MAX_YOMI_STRING 50

#define NJD_MAX_CONNECT_CNT     6

/************************************************/
/*           Include files               */
/************************************************/
#include "njc.h"

/**********************************************/
/* Learning dictionary-related structure declarations                       */
/**********************************************/
/* Please see man pages for details 
 
 */
typedef struct {
    u16 f_hinsi;                                  /* Please see man pages for details */
    u16 b_hinsi;                                  /* Please see man pages for details */
    u8  yomi_len;                                 /* Please see man pages for details */
    u8  hyouki_len;                               /* Please see man pages for details */
    u8  additional_len;                           /* Please see man pages for details */
    NN_PADDING1;
    wchar_t   yomi[NJ_MAX_LEN +NJ_TERM_LEN];            /* Please see man pages for details */
    wchar_t   hyouki[NJ_MAX_RESULT_LEN + NJ_TERM_LEN];  /* Please see man pages for details */
    wchar_t   additional[NJ_MAX_ADDITIONAL_LEN + NJ_TERM_LEN];  /* Please see man pages for details */
    u32 attr;                                     /* Please see man pages for details */
    u16 stem_b_hinsi;                             /* Please see man pages for details */
    u8  fzk_yomi_len;                             /* Please see man pages for details */
    NN_PADDING1;
} NJ_LEARN_WORD_INFO;


/* Please see man pages for details 
 
 */
typedef struct word_que {
    u16  entry;           /* Please see man pages for details */
    u8   type;            /* Please see man pages for details */
    NN_PADDING1;
    u16  mae_hinsi;       /* Please see man pages for details */
    u16  ato_hinsi;       /* Please see man pages for details */
    u8   yomi_len;        /* Please see man pages for details */
    u8   hyouki_len;      /* Please see man pages for details */
    u8   yomi_byte;       /* Please see man pages for details */
    u8   hyouki_byte;     /* Please see man pages for details */
    u8   next_flag;       /* Whether to continue from the previous queue */
    NN_PADDING3;
} NJ_WQUE;

/**********************************************/
/* Same notation process-related structure declaration                     */
/**********************************************/
/* Please see man pages for details 
 
 */
typedef struct {
    /* Please see man pages for details */
    wchar_t work[(NJ_MAX_RESULT_LEN + NJ_TERM_LEN) * (NJ_MAX_CANDIDATE + 1)];
    /* Please see man pages for details */
    s16 current;
    NN_PADDING2;
} NJ_WORK_BUF;

/* Please see man pages for details 
 
 */
typedef struct {
    /* Please see man pages for details */
    wchar_t work[(NJ_MAX_LEN + NJ_TERM_LEN) * (NJ_MAX_YOMI_STRING + 1)];
    /* Please see man pages for details */
    s16 current;
    NN_PADDING2;
} NJ_YOMI_BUF;

/**********************************************/
/* Parsing process-related constant and structure declarations                 */
/**********************************************/
/* Please see man pages for details 
 
 */
/* Prediction-related */
#define NJ_ANALYZE_INITIAL                      0x0000 /* Please see man pages for details */
#define NJ_ANALYZE_NEXT_YOSOKU                  0x0001 /* Please see man pages for details */
#define NJ_ANALYZE_FORWARD_SEARCH               0x0002 /* Please see man pages for details */
#define NJ_ANALYZE_FORWARD_SEARCH_WITH_YOMINASI 0x0003 /* Please see man pages for details */
    /* Conversion-related */
#define NJ_ANALYZE_CONVERSION_MULTIPLE          0x0004 /* Please see man pages for details */
#define NJ_ANALYZE_CONVERSION_SINGLE            0x0005 /* Please see man pages for details */
#define NJ_ANALYZE_COMPLETE                     0x0006 /* Please see man pages for details */
#define NJ_ANALYZE_END                          0x0007 /* Please see man pages for details */

/* Please see man pages for details 
 
 */
typedef struct {
    NJ_RESULT   single_keep[2];               /* Please see man pages for details */
    u16   single_keep_len;              /* Please see man pages for details */
    NN_PADDING2;
    NJ_RESULT   multiple_keep[NJ_MAX_PHRASE]; /* Please see man pages for details */
    u16   multiple_keep_len;            /* Please see man pages for details */
    NN_PADDING2;
} NJ_ANALYZE_CONV_BUF;

/* Please see man pages for details 
 
 */
typedef struct {
    /* Parsing environment */
    NJ_DIC_SET  *dics;                  /* Please see man pages for details */
    NJ_DIC_SET  search_dics;            /* Please see man pages for details */
    u8    search_op;              /* Please see man pages for details */
    NN_PADDING3;

    NJ_CURSOR   cursor;                 /* Please see man pages for details */
    wchar_t     *yomi;                  /* Please see man pages for details */
    u16   prev_hinsi;             /* Please see man pages for details */
    /* Current parsing state */
    u16   type;                   /* Please see man pages for details */
    s16    level;                  /* Please see man pages for details */
    u16   no;                     /* Please see man pages for details */
    NJ_ANALYZE_OPTION option;           /* Please see man pages for details */
    /* Buffer for all candidate search */
    NJ_ANALYZE_CONV_BUF conv_buf;       /* Please see man pages for details */
    u16   yomi_len;               /* Please see man pages for details */
    u16   learn_cnt;              /* Please see man pages for details */
    s16    previous_selection_cnt; /* Please see man pages for details */
    NN_PADDING2;
} NJ_ANALYZE_ENV;


/* Please see man pages for details 
 
 */
typedef struct {
    NJ_LEARN_WORD_INFO  selection_data[NJ_MAX_RELATION_SEGMENT];    /* Please see man pages for details */
    NJ_LEARN_WORD_INFO  next_prediction_lword;                      /* Please see man pages for details */
    u8            selection_now;                              /* Please see man pages for details */
    u8            count;                                      /* Please see man pages for details */
    NN_PADDING2;
} NJ_PREVIOUS_SELECTION_INFO;

/* Please see man pages for details 
 
 */
typedef struct {
    /* Please see man pages for details 
     
     */
    u8 iwnn_now;
    
    /**********************************************/
    /*  mmapi.c                                   */
    /**********************************************/
    /* Please see man pages for details 
     
     
     
     
     
     */
    u8 mm_yomi_search_index;

    /* Please see man pages for details */
    u8 mm_yomi_fzk_len;

    /**********************************************/
    /*  ncconv.c                                  */
    /**********************************************/
    /* Please see man pages for details 
     
     
     
     
     
     
     */
    u8    njc_mode;

    /* Please see man pages for details */
    NJC_SENTENCE        m_ConvResult;

    /* Please see man pages for details */
    union {
        NJC_CONV        Conv;           /* Please see man pages for details */
        NJC_CANDIDATE   Cand;           /* Please see man pages for details */
    } m_Buf;

    NJC_CANDIDATE_WORK m_cwork;         /* Please see man pages for details */
    NJ_CURSOR m_ccur[NJ_MAX_LEN];       /* Please see man pages for details */

    /**********************************************/
    /*  ndldic.c                                  */
    /**********************************************/
    /* Please see man pages for details */
    NJ_WQUE que_tmp;

    /**********************************************/
    /*  ndtdic.c                                  */
    /**********************************************/
    /* Please see man pages for details */
    wchar_t learn_string_tmp[NJ_MAX_RESULT_LEN + NJ_TERM_LEN];
    /* Please see man pages for details */
    wchar_t muhenkan_tmp[NJ_MAX_RESULT_LEN + NJ_TERM_LEN];

    /**********************************************/
    /*  neapi.c                                   */
    /**********************************************/
    /* Please see man pages for details */
    NJ_PREVIOUS_SELECTION_INFO previous_selection;

    u32 prev_search_range[NJ_MAX_DIC][2];   /* Please see man pages for details */
#define NJ_SEARCH_RANGE_TOP     0                 /* Please see man pages for details */
#define NJ_SEARCH_RANGE_BOTTOM  1                 /* Please see man pages for details */

    /* Please see man pages for details 
     
     
     */
    NJ_RESULT relation_results[NJ_MAX_RELATION_RESULTS];
    u32 relation_results_count;


    /**********************************************/
    /*  nehomo.c                                  */
    /**********************************************/
    /* Please see man pages for details */
    union {
        NJ_WORK_BUF workbuf;  /* Please see man pages for details */
        NJ_YOMI_BUF yomibuf;  /* Please see man pages for details */
    } h_buf;

    /**********************************************/
    /*  nfapi.c                                   */
    /**********************************************/
    /* Please see man pages for details */
    NJ_ANALYZE_ENV environment;

    /* Please see man pages for details 
     
     
     
     
     */
    u8 relation_cand_flg;
    NN_PADDING3;

    /* Please see man pages for details 
     
     
     
     
     */
    u8 wk_relation_cand_flg[NJ_MAX_DIC];

    /* Please see man pages for details */
    NJ_OPTION option_data;

    /**********************************************/
    /*  nj_lib.h                                  */
    /**********************************************/
    NJ_DIC_SET dic_set;         /* Please see man pages for details */
    NJ_DIC_SET tmp_dic_set;     /* Please see man pages for details */

    NJ_STATE   state;           /* Please see man pages for details */

    struct {
        /* Please see man pages for details 
         
         
         
         */
        u8   commit_status;
        /* Please see man pages for details 
         
         */
        NN_PADDING1;
        u16  save_top;
        /* Please see man pages for details 
         
         */
        u16  save_bottom;
        /* Please see man pages for details 
         
         */
        u16  save_count;
    } learndic_status;

    /* Please see man pages for details */
    wchar_t tmp[NJ_MAX_RESULT_LEN + NJ_TERM_LEN];


} NJ_CLASS;

#define NJ_SET_ENV(x,y) ((x).dic_set = (y))


#define NJ_PUT_DIC_KEYWORD(x,y) nj_strcpy(&(x).keyword[0], &(y).dic_set.keyword[0])


#ifdef __cplusplus 
}
#endif

#endif /* _NJX_LIB_H_ */

