/*-----------------------------------------------------------------------*
 Project: iWnn API Demo: File Logging
 File:    fprintf.h

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law.  They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
*-----------------------------------------------------------------------*/
#ifndef _FPRINTF_H
#define _FPRINTF_H

#include <nn/fs.h>



#ifdef  NN_BUILD_DEBUG  //debug version log

#if defined(NN_EFFORT_SMALL)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_noopt_s.txt"
#elif defined(NN_EFFORT_FAST)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_noopt_f.txt"
#endif

#endif

#ifdef NN_BUILD_DEVELOPMENT //development version log
#if defined(NN_EFFORT_SMALL)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_verbose_s.txt"
#elif defined(NN_EFFORT_FAST)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_verbose_f.txt"
#endif

#endif

#ifdef NN_BUILD_RELEASE //release version log

#if defined(NN_EFFORT_SMALL)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_release_s.txt"
#elif defined(NN_EFFORT_FAST)
#define FPRINTF_FILE_PATH        "sdmc:/iWnn/Result1_release_f.txt"
#endif

#endif



#define FPRINTF_BUF_MAX_SIZE    512

void Fprintf(nn::fs::FileOutputStream *file, const wchar_t *format, ...);
void FprintUTF16BE(nn::fs::FileOutputStream *file,wchar_t *buf);

#endif /*_FPRINTF_H*/
