/*-----------------------------------------------------------------------*
 Project: iWnn API Multi Language Demo: System API Wrapper
 File:    multidic_sys.h

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law.  They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
 *-----------------------------------------------------------------------*/
#ifndef _MULTI_SYS_H_
#define _MULTI_SYS_H_

#include <nn/os.h>
#include <nn/dbg.h>
#include <nn/fs.h>
#include <nn/fnd.h>


//* Variable type 
typedef nn::fs::FileStream  MULTI_FILE;



//System-dependent functions
s32      internalStrcmp(wchar_t *s1, wchar_t *s2);
wchar_t* internalStrcpy(wchar_t *dst, wchar_t *src);
s32      internalStrlen(wchar_t *c);
s32     internalSprintf (u8 *dicSett, const s8 *fmt, ...);  
s32     internalFtell(MULTI_FILE*);
s32     internalFread(void *, s32, s32, MULTI_FILE *);
MULTI_FILE*   internalFopen(MULTI_FILE*, s8 *, s8 *); 
void    internalMemset(void *, s32, u32);
void*   internalMallocation(u8 *, u32);
void    internalFree(u8 *, void *);
void    internalFclose(MULTI_FILE*);          
u32     internalAtoi(const wchar_t *c);



#endif // _MULTI_SYS_H_ 
