/*-----------------------------------------------------------------------*
 Project: Roman Input Demo: Conversion of Roman letter to KANA letter
 File:    RomanLetter.h

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
 *-----------------------------------------------------------------------*/

#ifndef _ROMAN_LETTER_H_
#define _ROMAN_LETTER_H_


enum {
    // This input method must be implemented
    ROMAN_LETTER_BASIS        = 0,
    ROMAN_LETTER_BASIS_NUM    = 154,
    ROMAN_LETTER_BASIS_END    = ROMAN_LETTER_BASIS + ROMAN_LETTER_BASIS_NUM,
    ROMAN_LETTER_BASIS_NN     = 151,
    ROMAN_LETTER_BASIS_N      = 152,
    // This input method is best implemented as an addition
    ROMAN_LETTER_ADDITION     = ROMAN_LETTER_BASIS_END,
    ROMAN_LETTER_ADDITION_NUM = 41,
    ROMAN_LETTER_ADDITION_END = ROMAN_LETTER_ADDITION + ROMAN_LETTER_ADDITION_NUM,
    // Other input methods
    ROMAN_LETTER_OTHER        = ROMAN_LETTER_ADDITION_END,
    ROMAN_LETTER_OTHER_NUM    = 20,
    ROMAN_LETTER_OTHER_END    = ROMAN_LETTER_OTHER + ROMAN_LETTER_OTHER_NUM,
    // Total
    ROMAN_LETTER_NUM          = ROMAN_LETTER_OTHER_END
};


void RomanLetterConvert( wchar_t *str, wchar_t *dst );
void RomanLetterConvertEx(wchar_t *str, wchar_t *dst );

#endif//__ROMAN_LETTER_H_

