/*-----------------------------------------------------------------------*
 Project: Roman Input Demo: File Logging
 File:    fprintf.cpp

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law. They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
 *-----------------------------------------------------------------------*/
#include <cstdio>
#include <cstdarg>
#include <string>
#include "fprintf.h"

wchar_t strBuf[FPRINTF_BUF_MAX_SIZE];
extern s32 w_strlen(wchar_t *str);
/*
 
              
              
              
              

 
 
 

 
 */
void Fprintf(nn::fs::FileOutputStream *file, const wchar_t *format, ...){
    
    va_list list;
    
    
    va_start( list, format );
    vswprintf(strBuf,(size_t)FPRINTF_BUF_MAX_SIZE,format,list);
    
    file->Write(strBuf, (size_t)(w_strlen(strBuf)*sizeof(wchar_t)),true);
    va_end( list );

    
    return;
}
/*
 

 
 
 
 

 
 */
void FprintUTF16LE(nn::fs::FileOutputStream *file,wchar_t *buf){
    s32 strLen;
    u32 i;

    strLen = w_strlen(buf);
    for(i = 0 ;i < strLen;i++){
        file->Write((u8*)(&buf[i]),2,true);
    }
    return;
}
