/*-----------------------------------------------------------------------*
 Project: Roman Input Demo: Main Function
 File:    main.cpp

 Copyright (C)2009-2012 Nintendo Co., Ltd.  All rights reserved.

 These coded instructions, statements, and computer programs contain
 proprietary information of Nintendo of America Inc. and/or Nintendo
 Company Ltd., and are protected by Federal copyright law.  They may
 not be disclosed to third parties or copied or duplicated in any form,
 in whole or in part, without the prior written consent of Nintendo.

 $Revision: $
 *-----------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <nn/os.h>
#include <nn/dbg.h>
#include <nn/fs.h>
#include <nn/applet.h>
#include "RomanLetter.h"
#include "fprintf.h"

/*
 

 
 

 
 */
wchar_t *w_strcpy(wchar_t *dst, wchar_t *src) {

    wchar_t *ret = dst;


    while (*src != (wchar_t)'\0') {
        *dst++ = *src++;
    }
    *dst = *src;
    return ret;
}
/*
 

 

 
 */
s32 w_strlen(wchar_t *str) {

    s32 len=0;

    while (*str++ != (wchar_t)'\0') {
        len++;
    }
    return len;
}


/*
 
                
                
                
                

 

 
 */
wchar_t   roman[512];
wchar_t kana[512];
extern "C" void nnMain()
{
    u8     bom[2]={0xff,0xfe};
    

    nn::fs::FileOutputStream*   logFile=NULL;  //Log file output instance

    //Enabling the applet library
    nn::applet::Enable();

    //fs initialization
    nn::fs::Initialize();

    //SD Card initialization
    nn::Result result = nn::fs::MountSdmc();
    if( result.IsFailure() ){
        return;
    }    

    //Result output file (kanaUtf16.txt) initialization
    logFile = new (nn::fs::FileOutputStream);
    if(!logFile){
        while(1){}
    }
    logFile->Initialize(FPRINTF_FILE_PATH,true);
    //Write BOM symbol
    logFile->Write(bom,sizeof(bom),true);

    Fprintf(logFile,L"Roman Conversion Test\n");
    

    ////////////////////////////////
    //Pre-conversion alphabetic string setting 1
    ////////////////////////////////
    memset(roman,0,sizeof(roman));
    memset(kana,0,sizeof(kana));
    w_strcpy(roman,L"ASHITAITTA");

    //Convert from alphabetic characters (UTF16LE) to kana (UTF16LE)
    RomanLetterConvertEx(roman,kana);


    //Log output
    Fprintf(logFile,L"roman=");
    FprintUTF16LE(logFile,roman);
    Fprintf(logFile,L", kana=");
    FprintUTF16LE(logFile,kana);
    Fprintf(logFile,L"\n");


    ////////////////////////////////
    //Pre-conversion alphabetic string setting 2
    ////////////////////////////////
    memset(roman,0,sizeof(roman));
    memset(kana,0,sizeof(kana));
    w_strcpy(roman,L"kanni");
    
    //Convert from alphabetic characters (UTF16LE) to kana (UTF16LE)
    RomanLetterConvertEx(roman,kana);
    
    //Log output
    Fprintf(logFile,L"roman=");
    FprintUTF16LE(logFile,roman);
    Fprintf(logFile,L", kana=");
    FprintUTF16LE(logFile,kana);
    Fprintf(logFile,L"\n");


    ////////////////////////////////
    //Pre-conversion alphabetic string setting 3
    ////////////////////////////////
    memset(roman,0,sizeof(roman));
    memset(kana,0,sizeof(kana));
    w_strcpy(roman,L"kani");
    
    //Convert from alphabetic characters (UTF16LE) to kana (UTF16LE)
    RomanLetterConvertEx(roman,kana);
    
    //Log output
    Fprintf(logFile,L"roman=");
    FprintUTF16LE(logFile,roman);
    Fprintf(logFile,L", kana=");
    FprintUTF16LE(logFile,kana);
    Fprintf(logFile,L"\n");


    logFile->Finalize();
    delete logFile;
    NN_LOG("  roman Demo: Test End.\n");
    while(1){}
}
